clear; 
clc;
close all;
tic 
%mex -setup
% mex rir_generator.cpp
%==========================================================================
m                                =2; %Number of microphones
Nsources                         =3; % Number of sources 、
%==========================================================================
ByFmeans                         =0; %clustering algorithm used for mask estimation, 1 if kmeans and 0 if FCM
F                                =1024*2; %% SFFT  length F
sT                               =F/2+1;
overlap                          =1/8;% F*ovlp must be an integer. Nonoverlap length.
 wind                            ='hanning'; %% window function
 wlen                            =F;
 awin                            =hanning(wlen) ; % analysis window is a Hamming window
 navg                            =7;      % Number of consecutive overlapping FFT frames that are used to compute the 
                                             % sample mean estimate of covariance matrices   default 7,8     
% channeltype                      ='dev1';      %%         DateSet C.
% sourcetype                       ='male'; %% male or female    DateSet C.
channeltype                      ='RIR';      %%         DateSet C.
sourcetype                       ='speech'; %% male or female    DateSet C.

 rirlength                       =130; %%RT_60 setting
 microdistance                   =5;%% microphone distance 
 percent                         =8;%Density_based method parameter, Eq.(14), e.g. ensure 8% of total number of points in local region.
 recordtype                      ='synthconv'; %%% synthetic convolutive system model, DateSet C.
 RT60                             =0.1;
%%=====================Genarate mixture signals============================
%%==================Detail of Dataset C can be found in http://sisec.wiki.irisa.fr/tiki-index91fe.html?page=Audio+source+separation
cd build_mixtures
load_data;   
cd ..
%%%%=======================Source Length===================================
signal_size                     =size(mixture,1);
%=====================STFT to the mixtures=================================
 Wmethod                        ='whitening'; %%% Pre-processing: whitening to the covariance matrix
 [xw,W]                         =FFTtransformation(mixture,overlap,F,m,Wmethod,navg); 
%===============Calculate the local covariance matrix===================== 
 [Rx]                                                  =Corrf(xw,m,F,navg);
%==========Extract the eigenvectors from local covariance matrix===========
[eigenvectors]                               =Eigenvector_extraction_PCA(Rx,F); 
%=======================Proposed density-based clustering algorithm========
[est_H]      =Proposed_clustering_method(m,percent,F,eigenvectors,Nsources);
%=====================Dewhitening Process==================================
if   strcmp(Wmethod,'whitening')==1
  [xw,est_H]                        =postwhitening(xw,sT,W,est_H,Nsources);
end
%%===================Rescalling process====================================
for f                                          =1:sT 
     for i=2:m
     scaled_H(i,:,f)                           =est_H(i,:,f)./est_H(1,:,f);      
     end
     scaled_H(1,:,f)                           =ones(1,Nsources);
end
%=============================Mixing Channel Estimation====================
 for f =1:F/2
  [channeldb,Optmalpermutation,finalestH,H]           =channelestimation(origH,scaled_H,f); 
  cdb(f)                                              =channeldb;
 end
%=========================Lp-based method parameters setting===============
 stop                                               =15;  %%% Iteration step;                    
   p                                                =0.8; %%% Lp-norm parameter: p;
%%======================Source separation process==========================
[estS]   =Underdeterminded_sourcese_recover(xw,scaled_H,Nsources,m,p,stop);
 EstS                                               =permute(estS,[2,1,3]);
 %%===================Permutation process==================================
 [estsource,permuteS]=permutationprocess(Nsources,m,stop,F,xw,scaled_H,EstS); 
 %%===================Covert sources into time domain =====================
 separated                           =reconstruct_output(estsource,F,overlap,signal_size); 
 %%=================== Evulation Source Recover============================
[avgSDR]                             =SIRmeasure(separated,origS,Nsources);
   dB                                =avgSDR
  close all;
  resultdisplay(m,Nsources,mixture,origS,separated);

