function [SIR]=Input_SIR(convolved)

% convolved: N x J x I  (N samples, J mic, I sources)
% holds the signals recorded when only one source at a time is active

N=size(convolved,1);
J=size(convolved,2);
I=size(convolved,3);

%----- Input SIR --------------------------------
% conv_power=squeeze(sum(convolved.^2,1));  % size JxI
% for j=1:J
%     SIR(j)=max(conv_power(j,:))/(sum(conv_power(j,:))-max(conv_power(j,:)));
% end

for mic=1:J
    for so=1:I
        power_target=sum(convolved(:,mic,so).^2);
        power_jammer = sum(sum(convolved(:,mic,:).^2,1),3) - power_target;
        SIR(mic,so)=10*log10(power_target/power_jammer);
    end
end

